<template>
<div id="team-selection-state">
	<div class="side red">
		<team-selection-item
			v-for="player in red"
			:key="player.control"
			:locked="player.locked"
			:name="player.name"
		/>
	</div>
	<div class="side blue">
		<team-selection-item
			v-for="player in blue"
			:key="player.control"
			:locked="player.locked"
			:name="player.name"
		/>
	</div>
</div>
</template>

<script>
import TeamSelectionItem from "../components/TeamSelectionItem.vue"

export default {
	beforeDestroy () {
		window.clearInterval(this.interval)
	},
	components: { TeamSelectionItem },
	computed: {
		blue () {
			return this.players.filter((player) => (player.side === "blue"))
		},
		red () {
			return this.players.filter((player) => (player.side === "red"))
		}
	},
	data () {
		const players = JSON.parse(this.data)
		const teamsize = players.length / 2
		const human_players = players
			.filter((player) => {
				return !player.ai
			})
			.map((player, key) => {
				return {
					control: player.control,
					input: Input.list.find((input) => {
						if (player.control === "key") return input.type === "key"
						else return input.number === player.control && input.type === "pad"
					}),
					locked: false,
					name: player.name,
					side: (key % 2 === 0) ? "red" : "blue",
				}
			})

		return {
			teams: {
				blue: [],
				red: [],
			},
			players: human_players,
			teamsize,
		}
	},
	methods: {
		update () {
			let locked = {
				blue: this.blue.filter((player) => (player.locked)),
				red: this.red.filter((player) => (player.locked))
			}

			this.players.forEach((player) => {
				if (!player.locked) {
					if (player.input.get(CONTROLS.LX) > 0) {
						player.side = "blue"
					} else if (player.input.get(CONTROLS.LX) < 0) {
						player.side = "red"
					}
				}

				if (player.input.pressed(CONTROLS.MENU_ACCEPT)) {
					if (locked[player.side].length < this.teamsize && !player.locked) {
						player.locked = true
						locked[player.side]++
					}
				}
				if (player.input.get(CONTROLS.MENU_DECLINE)) {
					if (player.locked) {
						player.locked = false
						locked[player.side]--
					}
				}
			})

			if (locked.blue.length + locked.red.length === this.players.length) {
				UI.emit("SELECTED_TEAMS", this.players.map((player) => {
					return {
						control: player.control,
						side: player.side,
					}
				}))
			}
		}
	},
	mounted () {
		this.interval = window.setInterval(() => {
			this.update()
		}, 1000 / 200)
	},
	name: "team-selection-state",
	props: [ "data" ],
}
</script>

<style lang="less" scoped>
#team-selection-state {
	display: flex;
	height: 100%;
	margin: 0 auto;
	max-width: 120vh;
	width: 100%;
}

.side {
	color: white;
	display: flex;
	flex: 1;
	flex-direction: column;
	font-size: 4em;
	justify-content: center;
	margin: 1em;
	padding: 1em;

	&.blue {
		background-color: #66f;
	}

	&.red {
		background-color: #f66;
	}
}
</style>
